Change the value of the property sale.propertyvalue.modify

Scope: sale

Who can execute the method: administrator

This method updates the values of order properties.

Please note that this method accepts all property values of the order as input. If any property values are not provided, their current values will be removed from the order as a result of the request.

Method Parameters

Required parameters are marked with *

Name
type

Description

fields*
object

The root element that passes the request parameters in the form of a structure:

{
            "order":
            {
                "id": "value",
                "propertyValues": {
                    "orderPropsId": "value",
                    "value": "value"
                },
            }
        }
        

Parameter fields

Required parameters are marked with *

Name
type

Description

order*
object

An object containing the order ID and property values in the form of a structure:

"id": "value",
        "propertyValues": {
            "orderPropsId": "value",
            "value": "value"
        },
        

Parameter order

Required parameters are marked with *

Name
type

Description

id*
sale_order.id

Order ID

propertyValues*
object[]

An array of objects (see the description of the propertyValues object below), containing the order property ID and property value

Parameter propertyValues

Required parameters are marked with *

Value
type

Description

orderPropsId*
sale_order_property.id

Order property ID

value*
string

Order property value

Code Examples

How to Use Examples in Documentation

curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"fields":{"order":{"id":2066,"propertyValues":[{"orderPropsId":20,"value":"John Smith"},{"orderPropsId":21,"value":"johnsmith@example.com"},{"orderPropsId":22,"value":"+10907996161"},{"orderPropsId":25,"value":"0000073738"},{"orderPropsId":26,"value":"900 S Holland Ave, Springfield, MO 65806, United States"},{"orderPropsId":51,"value":"04/17/2024"},{"orderPropsId":52,"value":"Y"},{"orderPropsId":53,"value":"948"},{"orderPropsId":54,"value":"10"}]}}}' \
        https://**put_your_bitrix24_address**/rest/**put_your_user_id_here**/**put_your_webhook_here**/sale.propertyvalue.modify
        
curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"fields":{"order":{"id":2066,"propertyValues":[{"orderPropsId":20,"value":"John Smith"},{"orderPropsId":21,"value":"johnsmith@example.com"},{"orderPropsId":22,"value":"+10907996161"},{"orderPropsId":25,"value":"0000073738"},{"orderPropsId":26,"value":"900 S Holland Ave, Springfield, MO 65806, United States"},{"orderPropsId":51,"value":"04/17/2024"},{"orderPropsId":52,"value":"Y"},{"orderPropsId":53,"value":"948"},{"orderPropsId":54,"value":"10"}]}},"auth":"**put_access_token_here**"}' \
        https://**put_your_bitrix24_address**/rest/sale.propertyvalue.modify
        
try
        {
        	const response = await $b24.callMethod(
        		'sale.propertyvalue.modify', {
        			fields: {
        				order: {
        					id: 2066,
        					propertyValues: [{
        							orderPropsId: 20,
        							value: 'John Smith'
        						},
        						{
        							orderPropsId: 21,
        							value: 'johnsmith@example.com'
        						},
        						{
        							orderPropsId: 22,
        							value: '+10907996161'
        						},
        						{
        							orderPropsId: 25,
        							value: '0000073738'
        						},
        						{
        							orderPropsId: 26,
        							value: '900 S Holland Ave, Springfield, MO 65806, United States'
        						},
        						{
        							orderPropsId: 51,
        							value: '04/17/2024'
        						},
        						{
        							orderPropsId: 52,
        							value: 'Y'
        						},
        						{
        							orderPropsId: 53,
        							value: '948'
        						},
        						{
        							orderPropsId: 54,
        							value: '10'
        						},
        					],
        				},
        			}
        		}
        	);
        	
        	const result = response.getData().result;
        	console.info(result);
        }
        catch( error )
        {
        	console.error(error);
        }
        
try {
            $response = $b24Service
                ->core
                ->call(
                    'sale.propertyvalue.modify',
                    [
                        'fields' => [
                            'order' => [
                                'id'            => 2066,
                                'propertyValues' => [
                                    [
                                        'orderPropsId' => 20,
                                        'value'        => 'John Smith'
                                    ],
                                    [
                                        'orderPropsId' => 21,
                                        'value'        => 'johnsmith@example.com'
                                    ],
                                    [
                                        'orderPropsId' => 22,
                                        'value'        => '+10907996161'
                                    ],
                                    [
                                        'orderPropsId' => 25,
                                        'value'        => '0000073738'
                                    ],
                                    [
                                        'orderPropsId' => 26,
                                        'value'        => '900 S Holland Ave, Springfield, MO 65806, United States'
                                    ],
                                    [
                                        'orderPropsId' => 51,
                                        'value'        => '04/17/2024'
                                    ],
                                    [
                                        'orderPropsId' => 52,
                                        'value'        => 'Y'
                                    ],
                                    [
                                        'orderPropsId' => 53,
                                        'value'        => '948'
                                    ],
                                    [
                                        'orderPropsId' => 54,
                                        'value'        => '10'
                                    ],
                                ],
                            ],
                        ],
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . print_r($result, true);
        
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error modifying sale property value: ' . $e->getMessage();
        }
        
BX24.callMethod(
            'sale.propertyvalue.modify', {
                fields: {
                    order: {
                        id: 2066,
                        propertyValues: [{
                                orderPropsId: 20,
                                value: 'John Smith'
                            },
                            {
                                orderPropsId: 21,
                                value: 'johnsmith@example.com'
                            },
                            {
                                orderPropsId: 22,
                                value: '+10907996161'
                            },
                            {
                                orderPropsId: 25,
                                value: '0000073738'
                            },
                            {
                                orderPropsId: 26,
                                value: '900 S Holland Ave, Springfield, MO 65806, United States'
                            },
                            {
                                orderPropsId: 51,
                                value: '04/17/2024'
                            },
                            {
                                orderPropsId: 52,
                                value: 'Y'
                            },
                            {
                                orderPropsId: 53,
                                value: '948'
                            },
                            {
                                orderPropsId: 54,
                                value: '10'
                            },
                        ],
                    },
                }
            },
            function(result) {
                if (result.error()) {
                    console.error(result.error());
                } else {
                    console.info(result.data());
                }
            }
        );
        
require_once('crest.php');
        
        $result = CRest::call(
            'sale.propertyvalue.modify',
            [
                'fields' => [
                    'order' => [
                        'id' => 2066,
                        'propertyValues' => [
                            [
                                'orderPropsId' => 20,
                                'value' => 'John Smith'
                            ],
                            [
                                'orderPropsId' => 21,
                                'value' => 'johnsmith@example.com'
                            ],
                            [
                                'orderPropsId' => 22,
                                'value' => '+10907996161'
                            ],
                            [
                                'orderPropsId' => 25,
                                'value' => '0000073738'
                            ],
                            [
                                'orderPropsId' => 26,
                                'value' => '900 S Holland Ave, Springfield, MO 65806, United States'
                            ],
                            [
                                'orderPropsId' => 51,
                                'value' => '04/17/2024'
                            ],
                            [
                                'orderPropsId' => 52,
                                'value' => 'Y'
                            ],
                            [
                                'orderPropsId' => 53,
                                'value' => '948' // Corrected quotation marks
                            ],
                            [
                                'orderPropsId' => 54,
                                'value' => '10' // Corrected quotation marks
                            ],
                        ],
                    ],
                ]
            ]
        );
        
        echo '<PRE>';
        print_r($result);
        echo '</PRE>';
        

Response Handling

HTTP status: 200

{
            "result": {
                "propertyValues": [
                    {
                        "code": "DELIVERY_DATE",
                        "id": 13167,
                        "name": "Delivery Date",
                        "orderPropsId": 51,
                        "orderPropsXmlId": null,
                        "value": "04/17/2024"
                    },
                    {
                        "code": "DELEVERY_REQUIRED",
                        "id": 13168,
                        "name": "Delivery Required",
                        "orderPropsId": 52,
                        "orderPropsXmlId": null,
                        "value": "Y"
                    },
                    {
                        "code": "DOC",
                        "id": 13170,
                        "name": "Document confirming the right to purchase the product",
                        "orderPropsId": 53,
                        "orderPropsXmlId": null,
                        "value": {
                            "contentType": "image/jpeg",
                            "description": "",
                            "externalId": "89359a6dc806e5dc5404962d1be0ba42",
                            "fileName": "fit.jpeg",
                            "fileSize": "84058",
                            "handlerId": null,
                            "height": "800",
                            "id": "948",
                            "meta": "",
                            "moduleId": "fileman",
                            "originalName": "fit.jpeg",
                            "src": "/upload/medialibrary/5bd/ukgwed4vdxe1qaqv85pqrvdgq5moyhqh/fit.jpeg",
                            "subdir": "medialibrary/5bd/ukgwed4vdxe1qaqv85pqrvdgq5moyhqh",
                            "timestampX": "04/02/2024 09:13:29",
                            "versionOriginalId": null,
                            "width": "600"
                        }
                    },
                    {
                        "code": "MAX_DELIVERY_DAYS",
                        "id": 13171,
                        "name": "Deliver no later than (days after order)",
                        "orderPropsId": 54,
                        "orderPropsXmlId": null,
                        "value": "10"
                    },
                    {
                        "code": "FIO",
                        "id": 13163,
                        "name": "Full Name",
                        "orderPropsId": 20,
                        "orderPropsXmlId": null,
                        "value": "John Smith"
                    },
                    {
                        "code": "EMAIL",
                        "id": 13164,
                        "name": "E-Mail",
                        "orderPropsId": 21,
                        "orderPropsXmlId": null,
                        "value": "johnsmith@example.com"
                    },
                    {
                        "code": "PHONE",
                        "id": 13165,
                        "name": "Phone",
                        "orderPropsId": 22,
                        "orderPropsXmlId": null,
                        "value": "+10907996161"
                    },
                    {
                        "code": "LOCATION",
                        "id": 13166,
                        "name": "Location",
                        "orderPropsId": 25,
                        "orderPropsXmlId": "bx_63e3a3b974932",
                        "value": "0000073738"
                    },
                    {
                        "code": "ADDRESS",
                        "id": 13162,
                        "name": "Delivery Address",
                        "orderPropsId": 26,
                        "orderPropsXmlId": null,
                        "value": "900 S Holland Ave, Springfield, MO 65806, United States"
                    }
                ]
            },
            "time": {
                "start": 1712049055.756753,
                "finish": 1712049056.823234,
                "duration": 1.066481113433838,
                "processing": 0.7959079742431641,
                "date_start": "2024-04-02T12:10:55+02:00",
                "date_finish": "2024-04-02T12:10:56+02:00"
            }
        }
        

Returned Data

Name
type

Description

result
object

The root element of the response

propertyValues
sale_order_property_value[]

An array of objects containing information about order property values

time
time

Information about the request execution time

Error Handling

HTTP status: 400

{
            "error": 100,
            "error_description": "Could not find value for parameter {fields}"
        }
        

Name
type

Description

error
string

String error code. It may consist of digits, Latin letters, and underscores

error_description
error_description

Textual description of the error. The description is not intended to be shown to the end user in its raw form

Possible Error Codes

Code

Description

200040300020

Insufficient rights to change order property values

100

Parameter fields not specified or empty

0

Order not found

0

Required parameters not specified

0

Other errors (e.g., fatal errors)

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred, please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred, please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not allowed to be called using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The methods must be called using the HTTPS protocol

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block, to remove it you need to contact Bitrix24 technical support

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is available only on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user whose access token or webhook was used to call the method lacks permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the account administrator has allowed access to this application only for specific users

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the option "Temporary closure of the public part of the site". Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning